Educational Codeforces Round 81 (Rated for Div. 2) C - Obtain The String

C. Obtain The String
time limit per test1 second
memory limit per test256 megabytes
inputstandard input
outputstandard output
You are given two strings s and t consisting of lowercase Latin letters. Also you have a string z which is initially empty. You want string z to be equal to string t. You can perform the following operation to achieve this: append any subsequence of s at the end of string z. A subsequence is a sequence that can be derived from the given sequence by deleting zero or more elements without changing the order of the remaining elements. For example, if z=ac, s=abcde, you may turn z into following strings in one operation:

z=acace (if we choose subsequence ace);
z=acbcd (if we choose subsequence bcd);
z=acbce (if we choose subsequence bce).
Note that after this operation string s doesn’t change.

Calculate the minimum number of such operations to turn string z into string t.

Input
The first line contains the integer T (1≤T≤100) — the number of test cases.

The first line of each testcase contains one string s (1≤|s|≤105) consisting of lowercase Latin letters.

The second line of each testcase contains one string t (1≤|t|≤105) consisting of lowercase Latin letters.

It is guaranteed that the total length of all strings s and t in the input does not exceed 2⋅105.

Output
For each testcase, print one integer — the minimum number of operations to turn string z into string t. If it’s impossible print −1.

Example
inputCopy
3
aabce
ace
abacaba
aax
ty
yyt
outputCopy
1
-1
3

暴力模拟出来是TLE的,优化查找改为二分查找
思路:
二分查找

#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const ll MAXN = 1e6 + 5;

vector<int>v[26];

int main(){
	ios::sync_with_stdio(0);
	cin.tie(0);
	string s,t;
	int T;
	cin>>T;
	while(T--){
		cin>>s>>t;
		for(int i=0;i<26;i++) v[i].clear();//初始化
		for(int i=0;i<s.size();i++) v[s[i]-'a'].push_back(i);
		int cnt=1,k=0;
		for(int i=0;i<t.size();i++){
			int x=s[i]-'a';
			int l=lower_bound(v[x].begin(),v[x].end(),k)-v[x].begin();
			if(!v[x].size()){
				cnt=-1;
				break;
			}
			else if(l==v[x].size()) k=0,cnt++,i--;
			else k=v[x][l]+1;
		}
		cout<<cnt<<endl;
	}
	return 0;
}
发布了35 篇原创文章 · 获赞 4 · 访问量 4311

猜你喜欢

转载自blog.csdn.net/Meulsama/article/details/104120603